unit FormDbAdvGridAdvanceTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Phys.MySQLDef, FireDAC.UI.Intf,
  FireDAC.VCLUI.Wait, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool,
  FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.MySQL, Aurelius.Sql.MySQL,
  Aurelius.Schema.MySQL, Aurelius.Drivers.FireDac, Data.DB, FireDAC.Comp.Client,
  Aurelius.Comp.Connection, FireDAC.Comp.UI, Aurelius.Engine.ObjectManager,
  Aurelius.Linq, Aurelius.Comp.Manager, Aurelius.Bind.BaseDataset,
  Aurelius.Bind.Dataset, AdvUtil, Vcl.Grids, AdvObj, BaseGrid, AdvGrid,
  DBAdvGrid, Vcl.ExtCtrls, DBAdvGlowNavigator, AdvStyleIF, AdvAppStyler
  , Vcl.StdCtrls
  ,uEntidades, AdvOfficeButtons, AdvLabel
  ;

type
  TFormDBADVGRDTEST = class(TForm)
    FDPhysMySQLDriverLink1: TFDPhysMySQLDriverLink;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    AConn: TAureliusConnection;
    mysqlconn: TFDConnection;
    adsPessoas: TAureliusDataset;
    dsPessoas: TDataSource;
    mgr: TAureliusManager;
    navMestre: TDBAdvGlowNavigator;
    MyGrid: TDBAdvGrid;
    FormStyler: TAdvFormStyler;
    AdvLabel1: TAdvLabel;
    chkToggleRO: TAdvOfficeCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure adsPessoasNewRecord(DataSet: TDataSet);
    procedure chkToggleROClick(Sender: TObject);
  private
    procedure SetGridOptions(grd : TDBAdvGrid);
  public
    { Public declarations }
  end;

var
  FormDBADVGRDTEST: TFormDBADVGRDTEST;

implementation

{$R *.dfm}

procedure TFormDBADVGRDTEST.adsPessoasNewRecord(DataSet: TDataSet);
begin
  adsPessoas.FieldByName('id').AsString := '';
  adsPessoas.FieldByName('scoring').AsInteger := 50;
  adsPessoas.FieldByName('nome').AsString := '';
  adsPessoas.FieldByName('sobrenome').AsString := '';
end;

procedure TFormDBADVGRDTEST.chkToggleROClick(Sender: TObject);
begin
  MyGrid.Columns[MyGrid.ColCount - 1].ReadOnly := chkToggleRO.Checked;
end;

procedure TFormDBADVGRDTEST.FormCreate(Sender: TObject);
begin
  adsPessoas.Manager := mgr.ObjManager;
  adsPessoas.SetSourceCriteria(mgr.find<TPessoa>);
  adsPessoas.Open;

  SetGridOptions(MyGrid);
end;

procedure TFormDBADVGRDTEST.FormDestroy(Sender: TObject);
begin
  adsPessoas.Close;
end;


procedure TFormDBADVGRDTEST.SetGridOptions(grd : TDBAdvGrid);
begin
  with grd do begin
      Cursor := crDefault;
      DrawingStyle := gdsClassic;
      PageMode := true;
      AutoCreateColumns := True;
      AutoRemoveColumns := True;
      DatasetTypeAuto := False;
      DataSetType := dtNonSequenced;
      EditPostMode := epRow;

      with Navigation do begin
        AdvanceAuto := False;
        AdvanceAutoEdit := False;
        AdvanceOnEnter := True;
        AdvanceOnEnterLoop := False;
        AdvanceDirection := adLeftRightInRow;

        AllowCtrlEnter := False;
        AllowClipboardAlways := True;
        AllowClipboardRowGrow := False;
        AllowClipboardColGrow := False;
        AllowInsertRow := true;
        AlwaysEdit := true;
      end;

      Options := Options + [goColSizing];
      Options := Options + [goEditing];
      Options := Options - [goRowSelect, goRangeSelect];

      RefreshOnInsert := True;
      RefreshOnDelete := True;

      ShowBlankRow := false;
      FixedRowAlways := true;

      ScrollBars := ssBoth;
      HoverRowCells := [hcNormal, hcSelected];
      PrintSettings.DateFormat := 'dd/mm/yyyy';
      ShowUnicode := True;
  end;
end;

end.
