unit uEntidades;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy;

type
  TPessoa = class;
  
  [Entity]
  [Table('pessoas')]
  [Id('Fid', TIdGenerator.SmartGuid)]
  TPessoa = class
  private
    [Column('id', [TColumnProp.Required], 38)]
    Fid: string;
    
    [Column('nome', [], 40)]
    Fnome: Nullable<string>;
    
    [Column('sobrenome', [], 40)]
    Fsobrenome: Nullable<string>;
    
    [Column('datanascimento', [])]
    Fdatanascimento: Nullable<TDateTime>;
    
    [Column('scoring', [])]
    Fscoring: Nullable<Integer>;
    FProps: TDynamicProperties;
  public
    constructor Create;
    destructor Destroy; override;
    property id: string read Fid write Fid;
    property nome: Nullable<string> read Fnome write Fnome;
    property sobrenome: Nullable<string> read Fsobrenome write Fsobrenome;
    property datanascimento: Nullable<TDateTime> read Fdatanascimento write Fdatanascimento;
    property scoring: Nullable<Integer> read Fscoring write Fscoring;
    property Props: TDynamicProperties read FProps;
  end;
  

implementation

{ TPessoa }

constructor TPessoa.Create;
begin
  inherited;
  FProps := TDynamicProperties.Create;
end;

destructor TPessoa.Destroy;
begin
  FProps.Free;
  inherited;
end;

initialization
  RegisterEntity(TPessoa);

finalization

end.
